<?php
if (!class_exists('App_dir_require_once_onexgateway')) {
    class App_dir_require_once_onexgateway
    {
        public function is_file_php($file)
        {
            if (empty(trim($file))) return false;
            if (!is_file(trim($file))) return false;
            $file = basename(trim($file));
            $file = explode('.', trim($file));
            if (empty($file) || end($file) != 'php') return false;
            return true;
        }
        public function get_dir($dir = __DIR__)
        {
            $files = [];
            $remove_array = array('.', '..', 'header.php', 'footer.php', 'template', 'assets_template', 'vendor');
            if ($dir == __DIR__) {
                array_push($remove_array, "index.php", "functions.php");
            }
            // if(class_exists('nusoap_base')){
            array_push($remove_array, "nusoap.php");
            // }
            foreach (array_diff(scandir($dir), $remove_array) as $file) {
                if (is_dir($dir . "/" . $file)) {
                    $dir_files = $this->get_dir($dir . "/" . $file);
                    if (!empty($dir_files)) {
                        $files = array_merge($files, $dir_files);
                    }
                } else {
                    if ($this->is_file_php($dir . "/" . $file)) {
                        $files[] = $dir . "/" . $file;
                    }
                }
            }
            return ($files);
        }
        public function run()
        {
            foreach ($this->get_dir() as $file) {
                require_once($file);
            }
        }
    }
}


if (class_exists('App_dir_require_once_onexgateway')) {
    // if (class_exists("ReaderEntityFactory")) {
    //     require_once("vendor/autoload.php");
    // }
    (new App_dir_require_once_onexgateway())->run();
}

if (!class_exists('App_assets_add_onexgateway')) {
    class App_assets_add_onexgateway
    {
        public function is_file_assets($file)
        {
            if (empty(trim($file))) return false;
            if (!is_file(trim($file))) return false;
            $file = basename(trim($file));
            $file = explode('.', trim($file));
            $access_file_format = [
                'css',
                'js'
            ];
            if (empty($file) || !in_array(end($file), $access_file_format)) return false;
            return true;
        }
        public function get_dir($dir = __DIR__ . '/assets_template')
        {
            $files = [];
            if(!file_exists($dir)) return $files;
            $remove_array = array('.', '..');
            foreach (array_diff(scandir($dir), $remove_array) as $file) {
                if (is_dir($dir . "/" . $file)) {
                    $dir_files = $this->get_dir($dir . "/" . $file);
                    if (!empty($dir_files)) {
                        $files = array_merge($files, $dir_files);
                    }
                } else {
                    if ($this->is_file_assets($dir . "/" . $file) && !str_contains($file, 'notaddedauto')) {
                        $dir_with_out_base_dir = str_replace(__DIR__ . '/', '', $dir);
                        $files[] = $dir_with_out_base_dir . "/" . $file;
                    }
                }
            }
            return ($files);
        }
        public function run()
        {
            foreach ($this->get_dir() as $file) {
                $file_name = basename($file);
                $file_format = explode('.', trim($file_name));
                $file_format = end($file_format);
                $file_name_without_format = str_replace(['.js', '.css'], ['', ''], $file_name);
                if ($file_format == 'js') {
                    $in_footer = str_contains($file_name_without_format, 'pinheader') ? false : true;
                    wp_enqueue_script('onexgateway-' . $file_name_without_format, plugin_dir_url(__FILE__) . $file, ['jquery'], false, $in_footer);
                    wp_localize_script(
                        'onexgateway-' . $file_name_without_format,
                        'onexgateway_' . $file_name_without_format,
                        array(
                            'ajaxurl' => admin_url('admin-ajax.php'),
                        )
                    );
                } elseif ($file_format == 'css') {
                    wp_enqueue_style('onexgateway-' . $file_name_without_format, plugin_dir_url(__FILE__) . $file);
                }
            }
        }
    }
}

add_action('init', function () {
    // print_r((new App_assets_add())->get_dir());
});
if (class_exists('App_assets_add_onexgateway')) {
    // add_action('wp_enqueue_script', function () {
    (new App_assets_add_onexgateway())->run();
    // });
    // add_action('admin_enqueue_scripts', function () {
    //     (new App_assets_add_onexgateway())->run();
    // });
}
